' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/04/12 
'      : 2011/11/10 Q Xgɑ΂\CxguMouseUpvɕύX
'
' Circle Hough Sample Program
' -----------------------------------------------------------------
Public Class Form_CIRCLE_HOUGH_SAMPLE

    '摜i[̈
    Private m_image As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()
    'rfI̓NX
    Private m_video As FVIL.Video.CFviVideo
    '~ntoNX(փGbW@)
    Private m_houghcorrelation As FVIL.Hough.CFviCircleHoughCorrelationEdge = New FVIL.Hough.CFviCircleHoughCorrelationEdge()
    '~ntoNX(\[xGbW@)
    Private m_houghsobel As FVIL.Hough.CFviCircleHoughSobelEdge = New FVIL.Hough.CFviCircleHoughSobelEdge()
    'p[^ݒ ({)
    Private m_param As FVIL.Hough.CFviCircleHoughParam
    'p[^ݒ (GbWo)
    Private m_correlationparam As FVIL.Edge.CFviEdge2DCorrelationParam = m_houghcorrelation.ParamEdge
    'p[^ݒ (GbWo)
    Private m_sobelparam As FVIL.Edge.CFviEdge2DSobelParam = m_houghsobel.ParamEdge

    '\pI[o[CNX錾
    Private m_overlay As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    'GbW\pI[o[CNX錾
    Private m_overlayEdge As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    'ԌvNX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()

    'init@CݒtH[
    Public formBroseIni As Form_BROWSEINI = New Form_BROWSEINI()

    'init@CitpXj
    Public m_strIniFilePath As String
    'rfIfoCX̃I[v
    Private m_flgVideoOpened As Boolean
    'ԑp
    Dim msec As Double = 0

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        '~ntotB^IR{{bNX
        ComboBoxSelectFilter.Items.Clear()
        ComboBoxSelectFilter.Items.Add("փGbW")
        ComboBoxSelectFilter.Items.Add("\[x")
        ComboBoxSelectFilter.SelectedIndex = 0

        'o~̐FR{{bNX
        ComboBoxObjectColor.Items.Clear()
        ComboBoxObjectColor.Items.Add("~")
        ComboBoxObjectColor.Items.Add("~")
        ComboBoxObjectColor.Items.Add("~̐Fm")
        ComboBoxObjectColor.SelectedIndex = 2
    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> System.Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageView1.Image = Me.m_image

        'I[o[C̒ǉ
        CFviImageView1.Display.Overlays.Add(m_overlay)
        CFviImageView1.Display.Overlays.Add(m_overlayEdge)
    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        '`NA
        m_overlay.Figures.Clear()

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'ݒt@C̃[hƃfoCXI[v
                m_video = FVIL.Video.Function.CreateInstance(m_strIniFilePath)
                '摜TCY
                m_video.ChangeImageSize(m_image)
                m_flgVideoOpened = True

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                If (m_video.DeviceType <> FVIL.Video.DeviceType.RICE001) Then
                    NumericUpDownExposure.Value = m_video.ExposureTime
                Else
                    TabControlParam.TabPages.Remove(TabPageBoard)
                End If
                ButtonGrabOne.Enabled = True
            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        ElseIf (Form_BROWSEINI.UseFileFlg = True) Then
            ButtonGrabOne.Enabled = False
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If
    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Try
            '`NA
            m_overlay.Figures.Clear()
            m_overlayEdge.Figures.Clear()
            CheckBoxEdgeDisplay.Checked = False
            formBroseIni.UseFileFlg = False

            'foCX^Cv
            Select Case m_video.DeviceType
                Case FVIL.Video.DeviceType.FVC05, FVIL.Video.DeviceType.FVC06, FVIL.Video.DeviceType.FVC07, FVIL.Video.DeviceType.FV1300, FVIL.Video.DeviceType.GP440, FVIL.Video.DeviceType.RICE001
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    m_video.GrabImageSync(m_image)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3312
                    Dim video As FVIL.Video.CFviVideoFHC3312 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3312)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3312 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3313
                    Dim video As FVIL.Video.CFviVideoFHC3313 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3313)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3313 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
            End Select
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged, ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged, NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' LoadFile {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͉摜t@C̃[hB
    ''' </remarks>
    Private Sub buttonLoadImageFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonLoadImageFile.Click
        '`NA
        m_overlay.Figures.Clear()
        ListViewResult.Items.Clear()

        Form_BROWSEINI.UseFileFlg = True
        '͉摜t@C̃[h
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Filter = "Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        OpenFileDialog1.Filter += "|Png t@C (*.png)|*.png"
        OpenFileDialog1.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        OpenFileDialog1.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        OpenFileDialog1.DefaultExt = "*.bmp"
        If ((OpenFileDialog1.FileNames.Length <= 0) Or (OpenFileDialog1.ShowDialog(Me) = System.Windows.Forms.DialogResult.Cancel)) Then
            Return
        End If

        Try
            FVIL.File.Function.LoadImageFile(OpenFileDialog1.FileName, m_image, FVIL.PixelMode.Unpacking)
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED,
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub

    ''' <summary>
    ''' ~ntos{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ~ntoEʕ\B
    ''' </remarks>
    Private Sub buttonDetection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonDetection.Click
        '\
        m_overlay.Figures.Clear()
        ListViewResult.Items.Clear()

        'ĕ`
        CFviImageView1.Refresh()

        'p[^ݒ
        If (fnCircleHoughPraramSet()) Then
            '~ntos
            If (fnCircleHoughExec()) Then
                'ʕ\
                fnResultDisplay()
            End If
        End If
    End Sub

    ''' <summary>
    ''' p[^ݒ
    ''' </summary>
    ''' <remarks>
    ''' p[^ݒ֐
    ''' </remarks>
    Private Function fnCircleHoughPraramSet() As Boolean
        'p[^ݒ
        If (ComboBoxSelectFilter.SelectedIndex = 0) Then
            'փGbWp[^ݒ
            m_param = m_houghcorrelation.Param
        Else
            '\[xGbWp[^ݒ
            m_param = m_houghsobel.Param
        End If
        m_param.Resolution = Double.Parse(TextBoxResolution.Text.ToString())
        m_param.RadiusMin = Double.Parse(TextBoxRadiusMin.Text.ToString())
        m_param.RadiusMax = Double.Parse(TextBoxRadiusMax.Text.ToString())
        m_param.QRange = NumericUpDownQRange.Value
        m_param.EdgePercent = NumericUpDownEdgePercent.Value
        m_param.MinScore = NumericUpDownMinScore.Value
        Select Case (ComboBoxObjectColor.SelectedIndex)
            Case 0
                m_param.ObjectColor = FVIL.Hough.ObjectColor.Black
            Case 1
                m_param.ObjectColor = FVIL.Hough.ObjectColor.White
            Case 2
                m_param.ObjectColor = FVIL.Hough.ObjectColor.BlackOrWhite
        End Select
        m_param.MergeCenter = NumericUpDownMergeCenter.Value
        m_param.MergeRadius = NumericUpDownMergeRadius.Value

        'GbWop[^ݒ
        If (ComboBoxSelectFilter.SelectedIndex = 0) Then
            'փGbWp[^ݒ
            m_correlationparam = m_houghcorrelation.ParamEdge
            Dim temp1 As Integer = NumericUpDownRegionHeight.Value
            Dim temp2 As Integer = NumericUpDownRegionWidth.Value
            If ((temp1 <= temp2) And ((temp1 * temp2) <= 255)) Then
                m_correlationparam.RegionWidth = NumericUpDownRegionWidth.Value
                m_correlationparam.RegionHeight = NumericUpDownRegionHeight.Value
            Else
                MessageBox.Show("Ǐ̈TCY̏𖞂Ă܂", "Parameter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If
            m_correlationparam.SigmoidK = Double.Parse(TextBoxSigmoidK.Text.ToString())
            m_correlationparam.VarThreshold = Double.Parse(TextBoxVarThreshold.Text.ToString())
            m_correlationparam.EdgeThreshold = NumericUpDownEdgeThreshold.Value
            m_correlationparam.NmsLength = NumericUpDownNmsLength.Value
            '{[_[
            If (CheckBoxBorderFlg.Checked) Then
                '[[h
                m_houghcorrelation.BorderMode = FVIL.BorderMode.Continuous
            Else
                '{[_[gȂ
                m_houghcorrelation.BorderMode = FVIL.BorderMode.None
            End If
        Else
            '\[xGbWp[^ݒ
            m_sobelparam = m_houghsobel.ParamEdge
            m_sobelparam.EdgeThreshold = NumericUpDownEdgeThreshold.Value
            m_sobelparam.NmsLength = NumericUpDownNmsLength.Value
            '{[_[
            If (CheckBoxBorderFlg.Checked) Then
                '[[h
                m_houghsobel.BorderMode = FVIL.BorderMode.Continuous
            Else
                '{[_[gȂ
                m_houghsobel.BorderMode = FVIL.BorderMode.None
            End If
        End If

        Return (True)
    End Function

    ''' <summary>
    ''' ~ntos
    ''' </summary>
    ''' <remarks>
    ''' ~ntos֐
    ''' </remarks>
    Private Function fnCircleHoughExec() As Boolean
        Dim Result As Boolean = False

        Try
            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                '摜ݒ
                m_houghcorrelation.SrcImages(0) = m_image
                'ԑJn
                m_timer.Start()
                'փGbW@ɂQGbWosA~ntos
                m_houghcorrelation.Execute()
                'ԑI
                msec = m_timer.Stop()
            Else
                '摜ݒ
                m_houghsobel.SrcImages(0) = m_image
                'ԑJn
                m_timer.Start()
                '\[xGbW@ɂQGbWosA~ntos
                m_houghsobel.Execute()
                'ԑI
                msec = m_timer.Stop()
            End If
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            Result = True
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        Return (Result)
    End Function

    ''' <summary>
    ''' ʕ\
    ''' </summary>
    ''' <remarks>
    ''' ʕ\֐
    ''' </remarks>
    Private Sub fnResultDisplay()
        Dim i As Integer
        Dim count As Integer
        Dim data As FVIL.Hough.CFviCircleHoughData

        'of[^̑擾
        If (ComboBoxSelectFilter.SelectedIndex = 0) Then
            'փGbW
            count = m_houghcorrelation.Result.Count
        Else
            '\[xGbW
            count = m_houghsobel.Result.Count
        End If

        For i = 0 To (count - 1)
            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                'փGbW
                data = m_houghcorrelation.Result(i)
            Else
                '\[xGbW
                data = m_houghsobel.Result(i)
            End If

            '~f[^
            Dim ol_circle As FVIL.GDI.CFviGdiCircle = New FVIL.GDI.CFviGdiCircle(data.ToCFviCircle())
            ol_circle.Pen.Color = System.Drawing.Color.Red

            'S
            Dim ol_center As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint()
            ol_center.Position = data.Center
            ol_center.Pen.Color = System.Drawing.Color.Red
            ol_center.Style = FVIL.GDI.FigureStyle.Cross
            ol_center.Size = New System.Drawing.Size(5, 5)

            'ԍ
            Dim ol_no As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString()
            ol_no.Text = i.ToString()
            ol_no.Position = data.Center
            ol_no.Align = FVIL.GDI.TextAlign.Right Or FVIL.GDI.TextAlign.Bottom
            ol_no.Color = System.Drawing.Color.Red

            'ǉ
            m_overlay.Figures.Add(ol_circle)
            m_overlay.Figures.Add(ol_center)
            m_overlay.Figures.Add(ol_no)

            'Xg\
            Dim listitem() As String = {i.ToString(), data.Center.X.ToString("0.00"), data.Center.Y.ToString("0.00"), data.Radius.ToString("0.00"), data.Score.ToString()}
            ListViewResult.Items.Add(New ListViewItem(listitem))
        Next

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' ~ntGbWo@IR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' փGbWE\[xGbW̑IB
    ''' </remarks>
    Private Sub ComboBoxSelectFilter_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxSelectFilter.SelectedIndexChanged
        If (ComboBoxSelectFilter.SelectedIndex = 0) Then
            'փGbWpp[^\
            NumericUpDownRegionHeight.Visible = True
            NumericUpDownRegionWidth.Visible = True
            TextBoxSigmoidK.Visible = True
            TextBoxVarThreshold.Visible = True
            labelRegionWidth.Visible = True
            labelRegionHeight.Visible = True
            labelSigmoidK.Visible = True
            labelVarThreshold.Visible = True
            labelCondition1.Visible = True
            labelCondition2.Visible = True
            labelCondition3.Visible = True
            'փGbWpp[^lݒ
            NumericUpDownEdgeThreshold.Maximum = 255
            NumericUpDownEdgeThreshold.Value = m_correlationparam.EdgeThreshold
            NumericUpDownNmsLength.Value = m_correlationparam.NmsLength
        Else
            'փGbWpp[^\
            NumericUpDownRegionHeight.Visible = False
            NumericUpDownRegionWidth.Visible = False
            TextBoxSigmoidK.Visible = False
            TextBoxVarThreshold.Visible = False
            labelRegionWidth.Visible = False
            labelRegionHeight.Visible = False
            labelSigmoidK.Visible = False
            labelVarThreshold.Visible = False
            labelCondition1.Visible = False
            labelCondition2.Visible = False
            labelCondition3.Visible = False
            '\[xGbWpp[^lݒ
            NumericUpDownEdgeThreshold.Maximum = 1023
            NumericUpDownEdgeThreshold.Value = m_sobelparam.EdgeThreshold
            NumericUpDownNmsLength.Value = m_sobelparam.NmsLength
        End If
    End Sub

    ''' <summary>
    ''' 摜GbW\`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜̃GbW̕\ؑւ܂B
    ''' </remarks>
    Private Sub checkBoxEdgeDisplay_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxEdgeDisplay.CheckedChanged
        Try
            If (CheckBoxEdgeDisplay.Checked = True) Then
                Dim edges_image As List(Of FVIL.Edge.CFviEdgeData)

                '`NA
                m_overlayEdge.Figures.Clear()
                'p[^ݒ
                fnCircleHoughPraramSet()

                If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                    '摜ݒ
                    m_houghcorrelation.SrcImages(0) = m_image
                    '~ntos(փGbW@)
                    m_houghcorrelation.Execute()
                    'Ώۉ摜̃GbW_
                    edges_image = m_houghcorrelation.GetEdges()
                Else
                    '摜ݒ
                    m_houghsobel.SrcImages(0) = m_image
                    '~ntos(\[xGbW@)
                    m_houghsobel.Execute()
                    'Ώۉ摜̃GbW_
                    edges_image = m_houghsobel.GetEdges()
                End If

                'GbW̕\
                Dim i As Integer
                For i = 0 To (edges_image.Count - 1)
                    Dim edge As FVIL.Edge.CFviEdgeData = edges_image(i)
                    'GbWʒu  }[N\ (0x)
                    Dim position As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint(edge.Position)
                    position.Size = New System.Drawing.Size(3, 1)
                    position.Style = FVIL.GDI.FigureStyle.Arrow
                    position.Angle = edges_image(i).Angle
                    position.Pen.Color = Color.Lime         '(0x00, 0xFF, 0x00)
                    m_overlayEdge.Figures.Add(position)
                Next
            Else
                m_overlayEdge.Figures.Clear()
            End If
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' ͈͐ݒ`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͈͂̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxSetArea_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxSetArea.CheckedChanged
        If (CheckBoxSetArea.Checked = True) Then
            '͈͐ݒpI[o[C\B
            CFviImageView1.Display.OverlayProcarea.Active = True
            'ĕ`
            CFviImageView1.Refresh()
        Else
            '͈͐ݒpI[o[C\B
            CFviImageView1.Display.OverlayProcarea.Active = False
            'ĕ`
            CFviImageView1.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        CFviImageView1.Display.Magnification = 1.0      '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`
    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageView1.FitImageSize()                   '\{𒲐
        CFviImageView1.Refresh()                        'ĕ`
    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`
    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`
    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageView1.Display.OverlayAscope.Enable = True
            CFviImageView1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageView1.Display.OverlayAscope.Enable = False
            CFviImageView1.Display.OverlayAscope.Active = False
        End If
        CFviImageView1.Refresh()                        'ĕ`
    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_flgVideoOpened = True) Then
            m_video.Close()
            m_flgVideoOpened = False
        End If
    End Sub

    ''' <summary>
    ''' VOCh֐KeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' VOCh֐̃p[^k̃G[oB
    ''' </remarks>
    Private Sub textBoxSigmoidK_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxSigmoidK.TextChanged
        Try
            m_correlationparam.SigmoidK = Double.Parse(TextBoxSigmoidK.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            TextBoxSigmoidK.Text = "1.0"
        End Try
    End Sub

    ''' <summary>
    ''' U臒leLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' U臒l̃G[oB
    ''' </remarks>
    Private Sub textBoxVarThreshold_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxVarThreshold.TextChanged
        Try
            m_correlationparam.VarThreshold = Double.Parse(TextBoxVarThreshold.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            TextBoxVarThreshold.Text = "25.0"
        End Try
    End Sub

    ''' <summary>
    ''' \eLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \̃G[oB
    ''' </remarks>
    Private Sub TextBoxResolution_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxResolution.TextChanged
        Try
            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                'փGbW
                m_houghcorrelation.Param.Resolution = Double.Parse(TextBoxResolution.Text.ToString())
            Else
                '\[xGbW
                m_houghsobel.Param.Resolution = Double.Parse(TextBoxResolution.Text.ToString())
            End If
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            TextBoxResolution.Text = "1.0"
        End Try
    End Sub

    ''' <summary>
    ''' ~̍ŏaeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ~̍ŏãG[oB
    ''' </remarks>
    Private Sub TextBoxRadiusMin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxRadiusMin.TextChanged
        Try
            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                'փGbW
                m_houghcorrelation.Param.RadiusMin = Double.Parse(TextBoxRadiusMin.Text.ToString())
            Else
                '\[xGbW
                m_houghsobel.Param.RadiusMin = Double.Parse(TextBoxRadiusMin.Text.ToString())
            End If
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            TextBoxRadiusMin.Text = "20.0"
        End Try
    End Sub

    ''' <summary>
    ''' ~̍ő唼aeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ~̍ő唼ãG[oB
    ''' </remarks>
    Private Sub TextBoxRadiusMax_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxRadiusMax.TextChanged
        Try
            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                'փGbW
                m_houghcorrelation.Param.RadiusMax = Double.Parse(TextBoxRadiusMax.Text.ToString())
            Else
                '\[xGbW
                m_houghsobel.Param.RadiusMax = Double.Parse(TextBoxRadiusMax.Text.ToString())
            End If
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            TextBoxRadiusMax.Text = "40.0"
        End Try
    End Sub

    ''' <summary>
    ''' Xg̃NbNɉĕ\ύX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Xg̃ACeւ̃NbNɉăI[oC̕\ύXB
    ''' </remarks>
    Private Sub ListViewResult_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListViewResult.MouseUp
        Dim index As Integer = 0

        'IXĝ݃I[o[C\AXgȊOIꍇSI[o[C\B
        For i As Integer = 0 To (ListViewResult.Items.Count - 1) Step 1
            Dim item As ListViewItem = ListViewResult.Items(i)
            Dim bEnable As Boolean

            'XgI
            If (ListViewResult.SelectedItems.Count > 0) Then
                bEnable = (item.Checked Or item.Selected)       'IACȅꍇTRUEݒ肵AȊOFALSEݒ肷
            Else
                bEnable = True                                  'XgȊOIꍇSTRUEݒ肷
            End If

            'IACe\i\jɂ
            m_overlay.Figures(index).Enable = bEnable
            m_overlay.Figures(index + 1).Enable = bEnable
            m_overlay.Figures(index + 2).Enable = bEnable
            index = index + 3
        Next
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

End Class
